import { L as LogRecord } from '../types-c7f989f9.js';
import { O as OTLPCloudflareExporterBaseConfig, a as OTLPCloudflareExporterBase } from '../OTLPCloudflareExporterBase-c3bdcb30.js';
import '@opentelemetry/api';
import '@opentelemetry/core';
import '@opentelemetry/resources';
import '@opentelemetry/otlp-exporter-base';

interface OTLPProtoLogExporterConfig extends OTLPCloudflareExporterBaseConfig {
}
declare class OTLPProtoLogExporter extends OTLPCloudflareExporterBase<OTLPProtoLogExporterConfig, LogRecord, Uint8Array> {
    contentType: string;
    static fromEnv(env: Record<string, unknown>): OTLPProtoLogExporter;
    convert(logRecords: LogRecord[]): Uint8Array;
    getUrl(config: OTLPCloudflareExporterBaseConfig): string;
}

export { OTLPProtoLogExporter, OTLPProtoLogExporterConfig };
